/******************************************************************************
 *
 *  Module BCDRIVER.H
 *
 *  Include file for the bc635PCI driver program for HALFEAGLE
 *
 *  Contains the structures needed for the LMSSTI CSC interface.
 ******************************************************************************
 *
 *  Revision History:
 *
 *     DATE      PGM  ECR#   DESCRIPTION
 *
 *  30-APR-1999  JDE  16028  Initial version.
 *
 ******************************************************************************
 */

/* Only load once */
#ifndef bcdriver_h
#define bcdriver_h

/*
 * The structure received from the bc635PCI board driver
 */
struct RAW_TIME_STRUCT
    {
      __int64 time;            /* Time as returned by BC635PCI TIME0 - TIME1 */
      __int64 planned;         /* Number of expected interrupts seen */
      __int64 unplanned;       /* Number of unexpected interrupts seen */
      int     mode;            /* Timing mode */
      int     format;          /* Timing format */
      int     year;            /* Year 1970 -- 2050 */
      int     sync;            /* Sync to 1 pps flag */
      int     n1;              /* Sync divider 1 */
      int     n2;              /* Sync divider 2 */
      int     code;            /* Time code format */
      int     modulation;      /* Time code modulation */
      int     offset;          /* timing offset */
      int     utc;             /* UTC support flag */
      int     leap_second;     /* Leap second count */
      int     leap_event;      /* Leap event direction */
      int     leap_event_time; /* Leap event time */
      int     fw_major;        /* Firmware major version number */
      int     fw_minor;        /* Firmware minor version number */
      int     fw_month;        /* Firmware month */
      int     fw_day;          /* Firmware day */
      int     fw_year;         /* Firmware year */
      int     source;          /* Clock source */
      int     jam;             /* JAM synch control flag */
      int     disciplining;    /* Disciplining control */
      int     phase;           /* Phase control flag */
      int     step;            /* Phase step */
      int     gain;            /* Disciplining gain */
      int     filter;          /* Filter constant */
      int     value;           /* D/A value */
    };


#endif

/* End of BCDRIVER.H */
